"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactVirtualized = require("react-virtualized");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var RefMultiGrid = /*#__PURE__*/function (_React$Component) {
  _inherits(RefMultiGrid, _React$Component);

  var _super = _createSuper(RefMultiGrid);

  function RefMultiGrid(props) {
    var _this;

    _classCallCheck(this, RefMultiGrid);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "resizeWidth", function () {
      if (_this.gridRef) {
        _this.gridRef.recomputeGridSize();
      }
    });

    _this.gridRef = /*#__PURE__*/_react.default.createRef();
    return _this;
  }

  _createClass(RefMultiGrid, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      var _this$props = this.props,
          prevWidth = _this$props.prevWidth,
          width = _this$props.width,
          setPrevWidth = _this$props.setPrevWidth,
          prevFixedColumnCount = _this$props.prevFixedColumnCount,
          fixedColumnCount = _this$props.fixedColumnCount,
          setPrevFixedColumnCount = _this$props.setPrevFixedColumnCount,
          prevColumns = _this$props.prevColumns,
          columns = _this$props.columns,
          setPrevColumns = _this$props.setPrevColumns;
      var isResize = false;

      if (prevWidth !== width) {
        setPrevWidth(width);
        isResize = true;
      }

      if (prevFixedColumnCount !== fixedColumnCount) {
        setPrevFixedColumnCount(fixedColumnCount);
        isResize = true;
      }

      if (prevColumns !== columns) {
        setPrevColumns(columns);
        isResize = true;
      }

      if (isResize) {
        this.resizeWidth();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      return /*#__PURE__*/_react.default.createElement(_reactVirtualized.MultiGrid, _extends({
        ref: function ref(_ref) {
          _this2.gridRef = _ref;
        }
      }, this.props));
    }
  }]);

  return RefMultiGrid;
}(_react.default.Component);

RefMultiGrid.propTypes = {
  prevWidth: _propTypes.default.number.isRequired,
  width: _propTypes.default.number.isRequired,
  setPrevWidth: _propTypes.default.func.isRequired,
  prevFixedColumnCount: _propTypes.default.number.isRequired,
  fixedColumnCount: _propTypes.default.number.isRequired,
  setPrevFixedColumnCount: _propTypes.default.func.isRequired,
  prevColumns: _propTypes.default.arrayOf(Object).isRequired,
  columns: _propTypes.default.arrayOf(Object).isRequired,
  setPrevColumns: _propTypes.default.func.isRequired
};
var _default = RefMultiGrid;
exports.default = _default;