"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ReactVirtualizedMultiGrid = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactVirtualized = require("react-virtualized");

var _orderBy2 = _interopRequireDefault(require("lodash/orderBy"));

var _keyBy2 = _interopRequireDefault(require("lodash/keyBy"));

var _isEmpty2 = _interopRequireDefault(require("lodash/isEmpty"));

var _slice2 = _interopRequireDefault(require("lodash/slice"));

var _map2 = _interopRequireDefault(require("lodash/map"));

var _forEach2 = _interopRequireDefault(require("lodash/forEach"));

var _RefMultiGrid = _interopRequireDefault(require("./RefMultiGrid"));

var _clsx = _interopRequireDefault(require("clsx"));

var _utils = _interopRequireDefault(require("./utils"));

var _constants = require("./constants");

var _stylesModule = _interopRequireDefault(require("./styles.module.css"));

var _excluded = ["fixedRowCount", "sortableColumn"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var getMapColumns = function getMapColumns(columns) {
  var newColumns = [];
  var totalWidth = 0;
  (0, _forEach2.default)(columns, function (col, index) {
    var width = col.width;
    width = Number(width) || _constants.DEFAULT_COLUMN_WIDTH;
    newColumns[index] = _objectSpread(_objectSpread({}, col), {}, {
      width: width
    });
    totalWidth += width;
  });
  (0, _forEach2.default)(newColumns, function (col, index) {
    var width = col.width;
    newColumns[index].percent = width / totalWidth;
  });
  return newColumns;
};

var getRows = function getRows(rows, sortBy, sortDirection, sorter) {
  if (!sortBy || typeof sorter !== 'function') {
    return rows;
  }

  return sorter(rows, sortBy, sortDirection);
};

var getValue = function getValue(multiple, value) {
  return multiple ? (0, _keyBy2.default)(value) : value;
};

var ReactVirtualizedMultiGrid = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(ReactVirtualizedMultiGrid, _React$PureComponent);

  var _super = _createSuper(ReactVirtualizedMultiGrid);

  function ReactVirtualizedMultiGrid(_props, context) {
    var _this;

    _classCallCheck(this, ReactVirtualizedMultiGrid);

    _this = _super.call(this, _props, context);

    _defineProperty(_assertThisInitialized(_this), "getClassName", function (className) {
      var classes = _this.props.classes;
      return (0, _clsx.default)([className, classes[className]]);
    });

    _defineProperty(_assertThisInitialized(_this), "setShiftIndex", function (shiftIndex) {
      _this.setState({
        shiftIndex: shiftIndex
      });
    });

    _defineProperty(_assertThisInitialized(_this), "changeSort", function (sortBy) {
      return function () {
        var _this$props = _this.props,
            onHeaderRowClick = _this$props.onHeaderRowClick,
            sorter = _this$props.sorter;
        var _this$state = _this.state,
            prevSortBy = _this$state.sortBy,
            prevSortDirection = _this$state.sortDirection,
            originalRows = _this$state.originalRows,
            shiftIndex = _this$state.shiftIndex;
        var sortDirection = _constants.SORT_DIRECTIONS.ASC;
        var reset = false;

        if (sortBy === prevSortBy) {
          if (prevSortDirection === _constants.SORT_DIRECTIONS.ASC) {
            sortDirection = _constants.SORT_DIRECTIONS.DESC;
          } else {
            reset = true;
          }
        }

        var currentSortBy = sortBy;
        var currentSortDirection = sortDirection;

        if (reset) {
          currentSortBy = '';
          currentSortDirection = '';
        }

        _this.setState({
          sortBy: currentSortBy,
          sortDirection: currentSortDirection,
          rows: getRows(originalRows, currentSortBy, currentSortDirection, sorter)
        });

        onHeaderRowClick({
          sortBy: currentSortBy,
          sortDirection: currentSortDirection
        });

        if (shiftIndex !== null) {
          _this.setShiftIndex(null);
        }
      };
    });

    _defineProperty(_assertThisInitialized(_this), "handleMultiple", function (value, id) {
      var newValue = _objectSpread({}, value);

      if (newValue[id]) {
        delete newValue[id];
      } else {
        newValue[id] = id;
      }

      return newValue;
    });

    _defineProperty(_assertThisInitialized(_this), "handleMultipleShift", function (value, index, rowKey, id, event) {
      var newValue = _objectSpread({}, value);

      var shiftIndex = _this.state.shiftIndex;

      if (event.shiftKey && shiftIndex !== null) {
        var rows = _this.state.rows;
        var min = Math.min(shiftIndex, index);
        var max = Math.max(shiftIndex, index) + 1;
        newValue = (0, _map2.default)((0, _slice2.default)(rows, min, max), rowKey);
      } else if (event.ctrlKey) {
        _this.setShiftIndex(index);

        newValue = _this.handleMultiple(newValue, id);
      } else {
        _this.setShiftIndex(index);

        newValue = _defineProperty({}, id, id);
      }

      return newValue;
    });

    _defineProperty(_assertThisInitialized(_this), "onRowClick", function (rowData, dataKey, index) {
      return function (event) {
        var _this$props2 = _this.props,
            onRowClick = _this$props2.onRowClick,
            rowKey = _this$props2.rowKey,
            multiple = _this$props2.multiple;
        var id = rowData[rowKey];
        var newValue = id;

        if (multiple) {
          var value = _this.state.value;
          newValue = _typeof(value) === 'object' ? value : {};

          if (multiple === _constants.MULTIPLE_SHIFT_MODE) {
            newValue = _this.handleMultipleShift(newValue, index, rowKey, id, event);
          } else {
            newValue = _this.handleMultiple(newValue, id);
          }

          newValue = Array.isArray(newValue) ? newValue : (0, _map2.default)(newValue);
        }

        onRowClick(newValue, rowData, index, dataKey, event); // event={ shiftKey: bool, ctrlKey: bool }
      };
    });

    _defineProperty(_assertThisInitialized(_this), "onHoverCell", function (rowIndex) {
      return function () {
        _this.setState({
          hover: rowIndex
        });
      };
    });

    _defineProperty(_assertThisInitialized(_this), "onTableChange", function (columns) {
      var onTableChange = _this.props.onTableChange;
      onTableChange(columns);
    });

    _defineProperty(_assertThisInitialized(_this), "onDragStart", function (columnIndex) {
      return function () {
        _this.dragColumnIndex = columnIndex;
      };
    });

    _defineProperty(_assertThisInitialized(_this), "onDrop", function (newIndex) {
      return function (e) {
        e.preventDefault();
        var oldIndex = _this.dragColumnIndex;

        if (oldIndex !== newIndex) {
          var columns = _this.state.columns;
          columns = (0, _utils.default)(columns, oldIndex, newIndex);
          columns = getMapColumns(columns);

          _this.setState({
            columns: columns
          });

          _this.onTableChange(columns);
        }

        e.currentTarget.style.boxShadow = 'none';
        e.currentTarget.style.border = 'none';
        e.currentTarget.style.opacity = 1;
      };
    });

    _defineProperty(_assertThisInitialized(_this), "onDragOver", function (e) {
      e.currentTarget.style.boxShadow = 'rgba(0, 0, 0, 0.24) 0px 3px 8px';
      e.currentTarget.style.border = '2px dotted #2196f3';
      e.currentTarget.style.opacity = 0.6;
    });

    _defineProperty(_assertThisInitialized(_this), "onDragLeave", function (e) {
      e.currentTarget.style.boxShadow = 'none';
      e.currentTarget.style.border = 'none';
      e.currentTarget.style.opacity = 1;
    });

    _defineProperty(_assertThisInitialized(_this), "headerCellRenderer", function (_ref) {
      var _classNameLabel;

      var key = _ref.key,
          columnIndex = _ref.columnIndex,
          style = _ref.style;
      var _this$props3 = _this.props,
          resizeColumn = _this$props3.resizeColumn,
          sortableColumn = _this$props3.sortableColumn;
      var _this$state2 = _this.state,
          columns = _this$state2.columns,
          sortBy = _this$state2.sortBy,
          sortDirection = _this$state2.sortDirection,
          alignClassName = _this$state2.alignClassName;
      var _columns$columnIndex = columns[columnIndex],
          dataKey = _columns$columnIndex.dataKey,
          label = _columns$columnIndex.label,
          sort = _columns$columnIndex.sort,
          align = _columns$columnIndex.align;
      var isSort = sortBy === dataKey;
      var ascSort = sortDirection === _constants.SORT_DIRECTIONS.ASC;
      var className = {};

      if (align && align !== 'left') {
        className[alignClassName[align]] = true;
      }

      if (resizeColumn) {
        className[_this.getClassName('ReactVirtualized__MultiGridTable__HeaderResize')] = true;
      }

      if (sortableColumn) {
        className[_this.getClassName('ReactVirtualized__MultiGridTable__HeaderSortable')] = true;
      }

      var classNameLabel = (_classNameLabel = {}, _defineProperty(_classNameLabel, _this.getClassName('ReactVirtualized__MultiGridTable__SortBy'), sort), _defineProperty(_classNameLabel, _this.getClassName('ReactVirtualized__MultiGridTable__AscSort'), isSort && ascSort), _defineProperty(_classNameLabel, _this.getClassName('ReactVirtualized__MultiGridTable__DescSort'), isSort && !ascSort), _classNameLabel);

      var onMouseMove = function onMouseMove(e) {
        return requestAnimationFrame(function () {
          var _this$state3 = _this.state,
              columns = _this$state3.columns,
              scrollLeft = _this$state3.scrollLeft;

          var _ref2 = _this.headerBeingResized || 0,
              offsetLeft = _ref2.offsetLeft;

          var width = scrollLeft + e.clientX - offsetLeft;

          if ((width || width === 0) && columns[_this.resizeIndex]) {
            var size = Math.max(100, width) || 100;
            columns[_this.resizeIndex].width = size;

            _this.setState({
              columns: columns.length > 100 ? _toConsumableArray(columns) : getMapColumns(columns),
              scrollToColumn: undefined
            });
          }
        });
      };

      var onMouseUp = function onMouseUp() {
        window.removeEventListener('mousemove', onMouseMove);
        window.removeEventListener('mouseup', onMouseUp);
        _this.headerBeingResized = null;
        _this.resizeIndex = null;

        _this.onTableChange(_this.state.columns);
      };

      var sortableProps = {};

      if (sortableColumn) {
        sortableProps = {
          draggable: true,
          onDragStart: _this.onDragStart(columnIndex),
          onDrop: _this.onDrop(columnIndex),
          onDragOver: _this.onDragOver,
          onDragLeave: _this.onDragLeave
        };
      }

      return /*#__PURE__*/_react.default.createElement("div", _extends({
        key: key,
        className: (0, _clsx.default)(_this.getClassName('ReactVirtualized__MultiGridTable__Cell'), _this.getClassName('ReactVirtualized__MultiGridTable__HeaderCell'), className),
        style: style
      }, sortableProps), /*#__PURE__*/_react.default.createElement("span", {
        tabIndex: "0",
        role: "button",
        "aria-pressed": "false",
        title: label,
        className: (0, _clsx.default)(_this.getClassName('ReactVirtualized__MultiGridTable__NonePointerEvents'), classNameLabel),
        onClick: _this.changeSort(dataKey)
      }, label), resizeColumn && /*#__PURE__*/_react.default.createElement("span", {
        className: _this.getClassName('ReactVirtualized__MultiGridTable__ResizeHandle'),
        onMouseDown: function onMouseDown(e) {
          e.preventDefault();
          _this.resizeIndex = columnIndex;
          _this.headerBeingResized = e.target.parentNode;
          window.addEventListener('mousemove', onMouseMove);
          window.addEventListener('mouseup', onMouseUp);
        }
      }));
    });

    _defineProperty(_assertThisInitialized(_this), "cellRenderer", function (_ref3) {
      var _className;

      var key = _ref3.key,
          columnIndex = _ref3.columnIndex,
          rowIndex = _ref3.rowIndex,
          style = _ref3.style;

      if (rowIndex === 0) {
        return _this.headerCellRenderer({
          key: key,
          columnIndex: columnIndex,
          style: style,
          rowIndex: rowIndex
        });
      }

      var _this$props4 = _this.props,
          rowKey = _this$props4.rowKey,
          multiple = _this$props4.multiple,
          classNameCell = _this$props4.classNameCell;
      var _this$state4 = _this.state,
          rows = _this$state4.rows,
          columns = _this$state4.columns,
          hover = _this$state4.hover,
          value = _this$state4.value,
          alignClassName = _this$state4.alignClassName;

      if ((0, _isEmpty2.default)(rows)) {
        return null;
      }

      var index = rowIndex - 1;
      var _columns$columnIndex2 = columns[columnIndex],
          dataKey = _columns$columnIndex2.dataKey,
          align = _columns$columnIndex2.align,
          render = _columns$columnIndex2.render;
      var rowData = rows[index];
      var label = rowData[dataKey] || '';
      var id = rowData[rowKey];
      var selected = value && multiple ? value[id] : value === id;
      var className = (_className = {}, _defineProperty(_className, _this.getClassName('ReactVirtualized__MultiGridTable__CellHover'), hover === rowIndex), _defineProperty(_className, _this.getClassName('ReactVirtualized__MultiGridTable__CellSelected'), selected), _className);

      if (align && align !== 'left') {
        className[alignClassName[align]] = true;
      }

      var classCell = classNameCell;

      if (classCell) {
        if (typeof classCell === 'function') {
          classCell = classCell(id, rowData, rowIndex);
        }

        className[classCell] = true;
      }

      var component = /*#__PURE__*/_react.default.createElement("span", {
        title: label
      }, label);

      if (render) {
        component = render(label, rowData, index);

        if (_typeof(component) !== 'object') {
          component = /*#__PURE__*/_react.default.createElement("span", {
            title: component
          }, component);
        }
      }

      return /*#__PURE__*/_react.default.createElement("div", {
        tabIndex: "0",
        role: "button",
        "aria-pressed": "false",
        key: key,
        className: (0, _clsx.default)(_this.getClassName('ReactVirtualized__MultiGridTable__Cell'), className),
        style: style,
        onClick: _this.onRowClick(rowData, dataKey, index),
        onMouseEnter: _this.onHoverCell(rowIndex),
        onMouseLeave: _this.onHoverCell(null)
      }, component);
    });

    _defineProperty(_assertThisInitialized(_this), "getColumnWidth", function (gridWidth) {
      return function (_ref4) {
        var index = _ref4.index;
        var columns = _this.state.columns;
        var _columns$index = columns[index],
            width = _columns$index.width,
            percent = _columns$index.percent;
        return Math.max((gridWidth - _constants.SCROLLBAR_WIDTH) * percent, width);
      };
    });

    _defineProperty(_assertThisInitialized(_this), "setPrevWidth", function (width) {
      _this.setState({
        prevWidth: width
      });
    });

    _defineProperty(_assertThisInitialized(_this), "setPrevFixedColumnCount", function (count) {
      _this.setState({
        prevFixedColumnCount: count
      });
    });

    _defineProperty(_assertThisInitialized(_this), "setPrevColumns", function (columns) {
      _this.setState({
        prevColumns: columns
      });
    });

    _defineProperty(_assertThisInitialized(_this), "setScrollLeft", function (value) {
      var scrollLeft = _this.state.scrollLeft;

      if (scrollLeft !== value) {
        _this.setState({
          scrollLeft: value
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onScroll", function (props) {
      var onScroll = _this.props.onScroll;
      onScroll(props);

      _this.setScrollLeft(props.scrollLeft);
    });

    var _columns = _props.columns,
        _rows = _props.rows,
        _sortBy = _props.sortBy,
        _sortDirection = _props.sortDirection,
        _sorter = _props.sorter,
        _multiple = _props.multiple,
        _value = _props.value,
        fixedColumnCount = _props.fixedColumnCount,
        scrollToColumn = _props.scrollToColumn;
    var mapColumns = getMapColumns(_columns);
    _this.state = {
      originalColumns: _columns,
      columns: mapColumns,
      originalRows: _rows,
      rows: getRows(_rows, _sortBy, _sortDirection, _sorter),
      originalValue: _value,
      value: getValue(_multiple, _value),
      prevSortBy: _sortBy,
      sortBy: _sortBy,
      prevSortDirection: _sortDirection,
      sortDirection: _sortDirection,
      hover: '',
      prevWidth: 0,
      prevFixedColumnCount: fixedColumnCount,
      prevColumns: mapColumns,
      alignClassName: {
        right: _this.getClassName('ReactVirtualized__MultiGridTable__Right'),
        center: _this.getClassName('ReactVirtualized__MultiGridTable__Center')
      },
      shiftIndex: null,
      scrollLeft: 0,
      scrollToColumn: scrollToColumn,
      prevScrollToColumn: scrollToColumn
    };
    return _this;
  }

  _createClass(ReactVirtualizedMultiGrid, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props5 = this.props,
          fixedRowCount = _this$props5.fixedRowCount,
          sortableColumn = _this$props5.sortableColumn,
          props = _objectWithoutProperties(_this$props5, _excluded);

      var _this$state5 = this.state,
          rows = _this$state5.rows,
          columns = _this$state5.columns,
          prevWidth = _this$state5.prevWidth,
          prevFixedColumnCount = _this$state5.prevFixedColumnCount,
          prevColumns = _this$state5.prevColumns,
          scrollLeft = _this$state5.scrollLeft,
          scrollToColumn = _this$state5.scrollToColumn;
      var sortableProps = {};

      if (sortableColumn) {
        sortableProps = {
          onDragOver: function onDragOver(e) {
            e.preventDefault();
          }
        };
      }

      return /*#__PURE__*/_react.default.createElement("div", _extends({
        style: {
          height: '100%',
          width: '100%'
        }
      }, sortableProps), /*#__PURE__*/_react.default.createElement(_reactVirtualized.AutoSizer, null, function (_ref5) {
        var width = _ref5.width,
            height = _ref5.height;
        return /*#__PURE__*/_react.default.createElement(_RefMultiGrid.default, _extends({
          height: height,
          width: width,
          fixedRowCount: fixedRowCount + 1,
          columnCount: columns.length,
          columnWidth: _this2.getColumnWidth(width),
          rowCount: rows.length + 1,
          cellRenderer: _this2.cellRenderer,
          prevWidth: prevWidth,
          setPrevWidth: _this2.setPrevWidth,
          prevFixedColumnCount: prevFixedColumnCount,
          setPrevFixedColumnCount: _this2.setPrevFixedColumnCount,
          prevColumns: prevColumns,
          setPrevColumns: _this2.setPrevColumns
        }, props, {
          columns: columns,
          scrollLeft: scrollLeft,
          scrollToColumn: scrollToColumn,
          onScroll: _this2.onScroll
        }));
      }));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      var newState = {};
      var sortBy = state.sortBy,
          sortDirection = state.sortDirection;

      if (props.sortBy !== state.prevSortBy) {
        newState.sortBy = props.sortBy;
        newState.prevSortBy = props.sortBy;
        sortBy = props.sortBy;
        newState.shiftIndex = null;
      }

      if (props.sortDirection !== state.prevSortDirection) {
        newState.sortDirection = props.sortDirection;
        newState.prevSortDirection = props.sortDirection;
        sortDirection = props.sortDirection;
        newState.shiftIndex = null;
      }

      if (props.columns !== state.originalColumns) {
        newState.columns = getMapColumns(props.columns);
        newState.originalColumns = props.columns;
      }

      if (props.rows !== state.originalRows) {
        newState.rows = getRows(props.rows, sortBy, sortDirection, props.sorter);
        newState.originalRows = props.rows;
        newState.shiftIndex = null;
      }

      if (props.value !== state.originalValue) {
        newState.value = getValue(props.multiple, props.value);
        newState.originalValue = props.value;
      }

      if (props.scrollToColumn !== state.prevScrollToColumn) {
        newState.scrollToColumn = props.scrollToColumn;
        newState.prevScrollToColumn = props.scrollToColumn;
      }

      return newState;
    }
  }]);

  return ReactVirtualizedMultiGrid;
}(_react.default.PureComponent);

exports.ReactVirtualizedMultiGrid = ReactVirtualizedMultiGrid;
ReactVirtualizedMultiGrid.defaultProps = {
  enableFixedColumnScroll: true,
  enableFixedRowScroll: true,
  hideTopRightGridScrollbar: true,
  hideBottomLeftGridScrollbar: true,
  style: _constants.STYLE,
  styleBottomLeftGrid: _constants.STYLE_BOTTOM_LEFT_GRID,
  styleTopLeftGrid: _constants.STYLE_TOP_LEFT_GRID,
  styleTopRightGrid: _constants.STYLE_TOP_RIGHT_GRID,
  styleBottomRightGrid: _constants.STYLE_BOTTOM_RIGHT_GRID,
  classes: _stylesModule.default,
  fixedColumnCount: 0,
  fixedRowCount: 0,
  scrollToColumn: undefined,
  scrollToRow: undefined,
  rowHeight: 35,
  rowKey: 'id',
  value: '',
  multiple: false,
  classNameCell: '',
  onRowClick: function onRowClick() {},
  onHeaderRowClick: function onHeaderRowClick() {},
  onScroll: function onScroll() {},
  sorter: function sorter(rows, sortBy, sortDirection) {
    return (0, _orderBy2.default)(rows, [sortBy], [sortDirection]);
  },
  sortBy: '',
  sortDirection: '',
  sortableColumn: false,
  resizeColumn: false,
  onTableChange: function onTableChange() {}
};
ReactVirtualizedMultiGrid.propTypes = {
  enableFixedColumnScroll: _propTypes.default.bool,
  enableFixedRowScroll: _propTypes.default.bool,
  hideTopRightGridScrollbar: _propTypes.default.bool,
  hideBottomLeftGridScrollbar: _propTypes.default.bool,
  style: _propTypes.default.instanceOf(Object),
  styleBottomLeftGrid: _propTypes.default.instanceOf(Object),
  styleTopLeftGrid: _propTypes.default.instanceOf(Object),
  styleTopRightGrid: _propTypes.default.instanceOf(Object),
  styleBottomRightGrid: _propTypes.default.instanceOf(Object),
  classes: _propTypes.default.instanceOf(Object),
  rows: _propTypes.default.arrayOf(Object).isRequired,
  columns: _propTypes.default.arrayOf(Object).isRequired,
  fixedColumnCount: _propTypes.default.number,
  fixedRowCount: _propTypes.default.number,
  scrollToColumn: _propTypes.default.number,
  scrollToRow: _propTypes.default.number,
  rowHeight: _propTypes.default.number,
  rowKey: _propTypes.default.string,
  value: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number, _propTypes.default.instanceOf(Array)]),
  multiple: _propTypes.default.oneOf([true, false, _constants.MULTIPLE_SHIFT_MODE]),
  classNameCell: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func]),
  onRowClick: _propTypes.default.func,
  onHeaderRowClick: _propTypes.default.func,
  onScroll: _propTypes.default.func,
  sorter: _propTypes.default.oneOfType([_propTypes.default.func, _propTypes.default.bool]),
  sortBy: _propTypes.default.string,
  sortDirection: _propTypes.default.oneOf([].concat(_toConsumableArray(Object.values(_constants.SORT_DIRECTIONS)), ['', null, false])),
  sortableColumn: _propTypes.default.bool,
  resizeColumn: _propTypes.default.bool,
  onTableChange: _propTypes.default.func
};
var _default = ReactVirtualizedMultiGrid;
exports.default = _default;